mem_bank_IOaddr equ     0461h
MemWindowAddr   equ     0Ch
MemWindowNative equ     08h

;----------------------------------------------------------------
;       PeriEnvCheck ( equiped peripherals ) BX4,Xe10 only !!!
;----------------------------------------------------------------
PeriEnvCheck    PROC    near
; port F0h      1= HDD/IF Ȃ ,  0=HDD/IF  _
; bit 6: ^Cv(SCSI)HDDXe[^X            40h 
; bit 5: ^Cv(SASI,IDE)HDDXe[^X        20h
                in      al,0F0h
                test    al,20h          ; Internal SASI/IDE exist?
;                jnz     noequip_ide    ; ̃vOłIDE BIOS
;                jnz     IDE_absent      ; ȂƂ̂̓G[ƂȂ
                OR      equip,IDE_equip
noequip_ide:    
                mov     dx,841Eh        ; DIP switch 𒲂ׂɍs@g
                in      al,dx
                test    al,02h          ; bit 1: Undoc2 ƈႤ̂Œ
                jz      noequip_sndbios ; Ap,As,Aeł͕ʂ̌o@I
                or      equip,SND_equip 
noequip_sndbios:        ; SASI BIOSׂ͒ȂƂɂ
                clc
                ret
IDE_absent:     stc
                ret
PeriEnvCheck    ENDP

D800_RAM        PROC   near
                mov     dx,043Fh ;
                mov     al,0A0h   ; clear cache
                out     dx,al
                mov     dx,mem_bank_IOaddr      ; 8-9 bank selected to
                mov     al,MemWindowAddr        ; address C000 or E000h.
                out     dx,al
                mov     dx,053Dh ; 053D_mem_enabler_switch
                mov     al,02h   ; RAM window access enable =bit2=0
                or      al,equip ; Internal IDE,SCSI,SND BIOS enable
                out     dx,al
                ret
D800_RAM        ENDP

D800_ROM        PROC   near
                mov     dx,mem_bank_IOaddr      ; 8-9 bank selected to
                mov     al,MemWindowNative      ; address 8000h or 10000h
                out     dx,al
                mov     dx,053Dh ; 053D_mem_enabler_switch
                mov     al,06h   ; RAM window access disable =bit2=1
                or      al,equip ; Internal IDE,SCSI,SND BIOS enable
                out     dx,al
                mov     dx,043Fh ;
                mov     al,0A0h  ; Invalidate CPU cache
                out     dx,al
                ret
D800_ROM        ENDP


IDE_patch_BX4   PROC   near     ; 4351MB ǂ@̃p^[`FbN
                call    IDEROMtoMEM     ; D800:0烁փRs[
                call    BX4_patch
                jc      PatchFail
                mov     dx,offset type4GB_msg
                call    _puts
PatchSuccess: ;  ɗĂ΃pb`͐
                mov     cx,(offset ExtendedCode_end - offset ExtendedCode)
                mov     si,offset EndMain
;                sub     si,10h
                mov     di,offset ExtendedCode ; g̃R[h2000h
            rep movsb   ; Rs[

                mov     al,ModeID
                mov     di,0007h
                stosb

                call    D800_RAM        ; D800:0 ݉\ɂ
                pushf
                cli     ; ]͊(int 11h)~߂Ă
                call    MEMtoROM        ; BIOSɓ]
                popf    ; ֎~
                CALL    D800_ROM ; $$$
                clc
                ret
PatchFail:   ; s̏ꍇCYtO
                stc
                ret
IDE_patch_BX4   ENDP
