IDE_WINDOW_SEG      equ   0D800h  ; IDE BIOSRAM window seg,EXIDEBX4ł͕ύX
;ST20L16                equ     1
;CHECK_CALENDAR         equ  9999
;PCIROM                 equ 2   ; PCIu[gROMp̏ꍇ`L, =boXp
;;PCIBIOS_PAT_INLINE    equ 6   ;  Internal PCI BIOS ROMp̏ꍇ`L
;------------------------------------------------------------------------------
;Ql\[XvOiAZuĂ̂܂ROMł킯ł͂܂j
; PC-9821X(4 devices) IDE BIOS patch V5.20  Copyright(C) 2004-06,17-25 DOSsoft
;------------------------------------------------------------------------------
code            segment 
                assume cs:code,ds:code,es:code,ss:code
                org 100h  ; for MS-DOS .COM file
start:
                jmp     program_start
include vars.h
MsgTitle  DB 0E1h,"IDE HDDeʏgCHSύXmANTI-CFؾān V5.20  "
IFDEF   PCIROM
  ifdef   PCIBIOS_PAT_INLINE
        DB "BIOSg"
  else
        DB "PCI{-hROM"
;        DB "Ʊ2064 "  ;
  endif
ELSE
        DB "PCIoXڋ@ C-BUS{-h"
ENDIF
CRLF_msg        DB      20h
                DB      13,10,0

.386
program_start:  ; WX^͕ۑS
ifdef   PCIBIOS_PAT_INLINE
                pushf
                pushad
                push    ds
                push    es
endif
                enter   28,0            ; X^bNϐgp
ifdef   PCIROM
                mov     ax,cs           
                mov     ds,ax           ; ESDSCSŊJn
                mov     es,ax           
endif
                cld                     ; ĂȂƈӊOƃgu
                mov     SegTVRAM,0A000h
                xor     ax,ax           ; ax=0
                mov     COLUMN,ax
                mov     StartLine,al
                mov     MachineType,al  ;=0
                mov     OldPCIPC,al     ;=0
                mov     Xe10BX4,al      ;=0
                call    CheckModel9821  ; nC]^gXW^9821̃`FbN
                jc      Invalid_PC9821  ; 9821 ID>21hłȂƂ
; chk
                call    GetDisplayLine  ; 98ITF̕\sǗɏ]
                mov     dx,offset MsgTitle 
                call    _puts   ; ^Cg\
;;JMP PatchCanceled   ; 2024-9-15 ǉidlύXj 

                push    ROW
                call    Scan_GRPH_FK6   ; 2025-2-18 dlύX
                pop     ROW
                jc      PatchCanceled   ; 2024-9-15 ǉidlύXj 

                call    PCI_Check       ; PCI BIOS݃`FbN
                jnc     MachineOK_PCI   ; L[ȂOK
                mov     dx,offset wrong_msg
                call    _puts           ; uΉȂ@v̕\
                jmp     PatchCanceled   ; 

MachineOK_PCI:
                call    GetMode         ; p[^[h̋LԂ\
                jc      PatchCanceled
ifdef PCIROM                            ; PCI ROM̎IDE/PCI bank
                call    BIOS_Bank_IDE   ; ؂ւD800ɏo
                call    D800_ROM        ; D800IDE BIOS
endif
                call    IDEBIOS_Check   ; IDE BIOSǂy`FbN
                jc      PatchFinished

                call    IDE_patch_main_PCImachine       ; pb`Ămain
                jnc     PatchFinished           ; L[ȂΐI
                mov     dx,offset wrong_bios 
                call    _puts                   ; ̕\
PatchFinished:  
                call    ShiftKeyCheck   ; VtgL[pause
ifdef PCIROM                            ; PCI BIOŜƂ
                call    D800_ROM        ; IDE/PCI BIOS, WP-RAM
                call    BIOS_Bank_PCI   ; PCIɖ߂Ă
else    ;   boXROM̂Ƃ PCIɂĂ͂Ȃ
                call    D800_WP         ; D800write protectԂɂ
endif
PatchCanceled:  
IFDEF   CHECK_CALENDAR  
                call    CheckCalendar   ; 
endif
                call    SetDisplayLine
Invalid_PC9821:                         ; G[ÎƂɔł
                leave                   ; X^bNϐJ
;WX^SČɖ߂
ifdef   PCIROM                          ; 
  IFDEF   PCIBIOS_PAT_INLINE            ; PCI BIOS̃R[̏
                pop     es
                pop     ds
                popad
                popf
                DB      9Ah             ; PCI BIOSgݍݔłł͂̌,
                DD      44000000h       ; CALL 4400:0000 R[,              
                RETF                    ; Ăяoɖ߂
  ELSE
                RET     ; PCI boot ROM100h[_nearŖ߂
  ENDIF
else
                RET    ; C-bus boot ROM100h[_nearŖ߂
endif
;=================================================================
;WarningOldPCIPC DB      0E1h," Xa7`10Ȃ ",0
WarningOldPCIPC DB      0E1h," PCI@ ",0
type4GB_msg     DB      0E1h,"IDE BIOS 4351MBg債܂. ",13,10,0
type8GB_msg     DB      0E1h,"IDE BIOS 8063MB Ή@. ",13,10,0
wrong_bios      DB      0C1h,"ΉĂȂIDE BIOSł.",13,10,0 ; 
ifdef PCIROM
wrong_msg       DB      0C1h,"PCI߾Ă݂܂. ΉĂȂ@ł.",0
else
;wrong_msg       DB      0C1h,"ΉĂȂPCI`bvZbg̋@ł.",0
wrong_msg       DB      0C1h,"ΉĂȂ@ł.",0
endif
absent_msg      DB      041h,"IDE BIOSoĂ܂iڑj",13,10,0

;
;--------------------------------------------------------
;       patch_PCI
;--------------------------------------------------------
IDE_patch_main_PCImachine      PROC    near
                call    PCIROMtoMEM     ; D800:0烁փRs[
                call    Ra300_patch     ; ܂ 4351MBǖ@ǂ
                jc      To4GLimitMachine ; łȂΎ
                mov     dx,offset type8GB_msg 
                call    _puts
                jmp     PatchSuccess
To4GLimitMachine:    ; 4351MB ǂ@̃p^[`FbN
                call    PCIROMtoMEM     ; D800:0烁փRs[iēxj
                call    Limit4351MB_patch
                jc      PatchFail
                mov     dx,offset type4GB_msg 
                call    _puts

                test    OldPCIPC,01h
                jz      PatchSuccess
                test    OldPCIPC,80h
                jz     @f
                ;mov     byte ptr WarningOldPCIPC,041h
        @@:     
                mov     dx,offset WarningOldPCIPC
                call    _puts
PatchSuccess: ;  ɗĂ΃pb`͐
                mov     cx,(offset ExtendedCode_end - offset ExtendedCode)
                mov     si,offset EndMain
;                sub     si,10h
                mov     di,offset ExtendedCode ; g̃R[h2000h
            rep movsb   ; Rs[

                call    D800_RAM        ; D800:0 ݉\ɂ
                pushf
                cli     ; ]͊(int 11h)~߂Ă
                call    MEMtoROM        ; BIOSɓ]
                popf    ; ֎~
                mov     dx,offset CRLF_msg
                clc
                ret
PatchFail:   ; s̏ꍇCYtO
                stc
                ret
IDE_patch_main_PCImachine     ENDP

include pcipam.s
;-------------------------------------------------------------------
;       MEMtoROM        MEMseg:0-->ES:0   ES=RAMwindow of IDE BIOS
;------------------------------------------------------------------
MEMtoROM        PROC    near
                cld
                mov     cx,2000h
                mov     si,0000h
                mov     di,0000h
                push    es      ; ES=D800h
                mov     ax,IDE_WINDOW_SEG
                mov     es,ax
                mov     ax,MEMseg
                push    ds      ; DS=MEMseg(5C00h)
                mov     ds,ax   ; DS=MEMseg, ES=RAMwindowIDE
           rep  movsb
                pop     ds
                pop     es
                ret
MEMtoROM        ENDP

;--------------------------------------------------------
;       PCIROMtoMEM        ds=D800:0-->MEMseg:0
;--------------------------------------------------------
PCIROMtoMEM     PROC    near
                cld
                mov     cx,2000h/2
                mov     si,0
                mov     di,0
                mov     dx,IDE_WINDOW_SEG
                mov     ax,MEMseg
                push    ds
                mov     ds,dx
                mov     es,ax
          rep   movsw
                pop     ds
                mov     al,ModeID
                mov     di,0007h
                stosb
                ret
PCIROMtoMEM     ENDP

;--------------------------------------------------------
;       BIOS_Bank_PCI   
;--------------------------------------------------------
BIOS_Bank_PCI   PROC    near
                mov     dx,063Ch
                in      al,dx
                mov     al,BIOS_BankStat; ݂̒l
                and     al,0FCh
                or      al,01h          ; PCI BIOS01b, PnP11b
                out     dx,al
                ret
BIOS_Bank_PCI   ENDP

;--------------------------------------------------------
;       BIOS_Bank_IDE
;--------------------------------------------------------
BIOS_Bank_IDE   PROC    near
                mov     dx,063Ch
                mov     al,BIOS_BankStat; ݂̒lۊ
                and     al,0FCh         ; IDE BIOS00b
                out     dx,al
                ret
BIOS_Bank_IDE   ENDP

;--------------------------------------------------------
;       machines        ǉ
;--------------------------------------------------------
include Ra300pat.inc    ; pb`R[h  8063MB(32255MB)@p
include lim4351M.inc    ; pb`R[h  4351MB @pi{PCI@pj 
include paramset.s      ; L[ɂ郂[hI[`

;--------------------------------------------------------
;       CheckModel9821
;--------------------------------------------------------
CheckModel9821  PROC    near
                push    ds
                xor     ax,ax
                mov     ds,ax
                mov     cl,ds:[0501h]   ; nC]tOق
                mov     ch,ds:[0458h]   ; gXWtOق
                mov     ax,0F8E8h
                mov     ds,ax
                mov     ax,ds:[0000h]   ; 9821CfBP[^
                mov     dl,ds:[003Fh]   ; @ID
                mov     dh,ds:[0005h]   ; PCItOق
                pop     ds

                test    cl,08h
                jnz     IsNot9821       ; hireso
                test    ch,80h
                jnz     IsNot9821       ; H98
                cmp     ax,2198h
                JE      Is9821series
IsNot9821:      stc     ; 9821łȂƂCY
                ret
Is9821series: ; 9821̉̋@ł
                cmp     dl,21h
                je      IsOldPCIPC
                cmp     dl,23h
                je      IsOldPCIPC
                cmp     dl,24h
                je      IsOldPCIPC
                cmp     dl,25h
                je      IsOldPCIPC
                cmp     dl,2Ah
                je      IsOldPCIPC

                cmp     dl,29h
                je      IsXe10BX4
                cmp     dl,22h
                je      IsXe10BX4
                jmp     Is9821
                cmp     dl,21h
                jae     Is9821
IsXe10BX4:      or      Xe10BX4,1
                STC     ; <---- EXIDEPCIłCY,EXIDEBX4ł NC $$$
                RET
Is9821:         clc     ; <----
                ret
IsOldPCIPC:     or      OldPCIPC,80h
                clc
                ret
CheckModel9821  ENDP
;-------------------------------------------------------------------------------
include ideptcom.inc    ; PCI^PCI@routine,\[Ẍʒu͕ύX֎~

include e:\asmlib\putstrCS.inc   ; CS:DX\[`_puts͕t܂
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
dmy             DD      0EEEEEEEEh      ; Ԃʂ邽߂̃_~[i폜֎~j
align 16
;   extdcode̐擪ł 2000hɓǂݑւ邽߃\[Ẍʒu̕ύX֎~
;-------------------------------------------------------------------------------
EndMain  label word  ; 
; oCił͏̋󔒂폜Ă悢
org     2000h   ; 5x00:2000Ɉʒu邱ƂɂȂ
include xcode4d.inc    ; Ă΂Ƃ2000hAf[^ANZX͂̑
;========================================================================
align 4
        DB      0,0h
        DB      "̃vO̕ւ܂B",0,0,"(C)2025 ܂",0
        DB      150h dup(0) ; _~[̋

code    ends
        end     start
