; ŎsR[h
;--------------------------------------------------------
;       GetDisplayLine       input   ES = VRAM segment
;--------------------------------------------------------
MSG_DISP_LINE   equ     14
GetDisplayLine  PROC    near
                push    ds
                mov     dl,MSG_DISP_LINE   
                xor     ax,ax           ; AH=0
                mov     COLUMN,ax
                mov     ds,SegTVRAM
                mov     al,ds:[3FE0h]   ; ITF\sǗAhX
                cmp     al,dl
                jb      LineIndicatorOK
                mov     al,dl
LineIndicatorOK:
                inc     ax
                mov     ROW,ax
                mov     StartLine,al
                pop     ds
                ret
GetDisplayLine  ENDP

;--------------------------------------------------------
;       SetDisplayLine
;--------------------------------------------------------
SetDisplayLine  PROC   near
                push    ds
                mov     ax,ROW
                mov     ds,SegTVRAM
                mov     ds:[3FE0h],al    ; [ITF\sǗAhX]
                pop     ds
                ret
SetDisplayLine  ENDP


;----------------------------------------------------------------------
;       GetMode         2025/3/24
;----------------------------------------------------------------------
GetMode         PROC    near
                push    cs
                pop     es              ; es=csɂ

                mov     dx,891Eh        ; S-DIPXCb`
                in      al,dx
                cmp     al,7Fh          ; Undefined (default)
                jne     @f
                mov     al,01h          ; peBtO͒uƂĂPɏ
        @@:
                mov     ah,al           ; AHɂꎞۑ
                and     ah,11110000b    ; bit 3-0
                
                and     al,00001111b    ; AL,bit7-4 ͕ʗprȂ̂Ń}XN
                or      al,al           ; [̏ꍇ͖lł̏
                jnz      @f             ; 
                mov     al,1            ; ̏ꍇlPɂ
        @@:     
;;;;;           or      al,ah           ; ۑĂ4bitlƂorigȂj
                mov     ModeID,al       ; [Jɕۑ

                mov     dx,offset msg_DIPSW8C1E
                call    _puts
                mov     al,ModeID
                cmp     al,10
                jne     @f
; l10̂Ƃ
                push    ax
                mov     di,(offset mode10 - 3 )
                mov     ax,2020h
                stosw
                mov     al,2Ch
                stosb
                pop     ax

                mov     byte ptr cs:mode2,0C1h
          @@:   and     al,7
                mov     ah,0
                call    digit_1             ; ̒l\

                cmp     ModeID,5
                jne     @f
                mov     di,(offset mode5 - 3 )
                mov     ax,2020h
                stosw
                stosb
        @@:     
                mov     al,ModeID
                mov     ah,0
                shl     ax,1
                mov     bx,offset ParaMsgBase
                add     bx,ax
                mov     dx,ds:[bx]
                call    _puts           ; [hl̕񂩂\
                cmp     ModeID,6
                je      @f
                clc
                RET
        @@:
                stc
                RET
;p[^
;msg_DIPSW8C1E   DB      0E1h,"[hݒ",0 
;msg_DIPSW8C1E   DB      0E1h,"ҰӰ",0 
msg_DIPSW8C1E   DB      0E1h,"߅ՅЅ х ",0 
ParaMsgBase     label   word
                DW      offset mode0
                DW      offset mode1
                DW      offset mode2
                DW      offset mode3
                DW      offset mode4
                DW      offset mode4
                DW      offset mode6
                DW      offset mode0
                DW      offset mode0
                DW      offset mode0
                DW      offset mode2
mode0   DB      081h," `",13,10,0
mode1   DB      0E1h," IDEg SSD,CFœK[hi4351MBȉH:S͘_8:17,󅰅16:63j",13,10,0
mode2   DB      0E1h," IDEg HD݊[h(4351MBȉ H:S=8:17)",13,10,0
mode10  DB           " 32GBȏ 16:255",13,10,0
mode3   DB      0E1h," SCSI݊[hiSSD,CFœKj",13,10,0
mode4   DB      0E1h," SCSI݊[hiHDDœKj",13,10,0
mode5   DB           "32GBȏIFC-USP݊",13,10,0
mode6   DB      0E1h," DIV0ROM ݂̂Kp",13,10,0
GetMode         ENDP

;--------------------------------------------------------
;       IDEBIOS_Check (PCI machines)
;--------------------------------------------------------
IDEBIOS_Check   PROC    near
                mov     dx,063Ch
                in      al,dx
call D800_ROM
                mov     BIOS_BankStat,al    ; ݂̒lۊ
                push    ds
                mov     ax,IDE_BIOS_SEG_D800
                mov     ds,ax
                mov     eax,ds:[0008h]   ; ? C-BUS ROM
                pop     ds
IF 0
                test    OldPCIPC,80h ;  2025/1/25 
;;;             jz      @f
                cmp     eax,00000090h   ; PCI BIOS
                jne     @f
                call    D800_WP
                call    BIOS_Bank_IDE
        @@:
ENDIF
                cmp     eax,2AAA5590h
                je      IDEBIOS_Check_OK
                cmp     eax,3AAA5590h
                je      IDEBIOS_Check_OK
IDEBIOS_Check_NG:
                mov     dx,offset absent_msg
                call    _puts
                stc
                ret
IDEBIOS_Check_OK:
                clc
                ret
IDEBIOS_Check   ENDP   


IF 0
;----------------------------------------------------------------------
;       DisplayBoardAddr  
;----------------------------------------------------------------------
DisplayBoardAddr  PROC    near
                mov     ax,COLUMN
                push    ax
                mov     ax,ROW
                push    ax
                inc     ax
                inc     ax
ifNdef  PCIROM
                mov     ROW,0
ifdef PCIROM
                mov     COLUMN,80-35
                mov     dx,offset location_msg
                call    _puts
else
                mov     COLUMN,80-6
endif
                mov     ax,cs:[00F8h]
                call    digit_1
ENDIF
                pop     ax
                mov     ROW,ax
                pop     ax
                mov     COLUMN,ax
                RET
DisplayBoardAddr  ENDP
ENDIF




;--------------------------------------------------------
;       ShiftKeyCheck
;--------------------------------------------------------
ShiftKeyCheck   PROC    near
LoopPressShift: mov     ah,02h
                int 18h
                test    al,00011001b    ; 1=SHIFT, 8=GRPH, 16=CTRL
                jnz     LoopPressShift
                ret
ShiftKeyCheck   ENDP


;--------------------------------------------------------------------
;       scan_pattern     ̔r[`    for IDE BIOS 
;       <input>
;       DS:SI rp^[,         CX p^[̃oCg
;       ES:DI p^[ꏊ,         DX ͈̔̓oCg
;       <output>        < j AX,BX,CX,DX,DI >
;       CY =NONE ,  NC= ES:BX   carry0̂Ƃ  ES:BXɌoꏊԂ
;--------------------------------------------------------------------
scan_pattern     PROC    near
                mov     di,0040h
                sub     cx,si
                mov     dx,2000h-40h
                sub     dx,cx
                cld

                xor     bx,bx
                add     dx,di
scan_ent:       mov     ax,ds:[si]
                cmp     ax,es:[di]
                jnz     scan_No_match
                mov     bx,di
                push    cx
                push    si
                push    di
         repz   cmpsb
                or      cx,cx
                pop     di
                pop     si
                pop     cx
                jnz     scan_No_match
                clc                     ; scan OK
                ret
scan_No_match:  inc     di
                cmp     di,dx
                jb      scan_ent
                stc                     ; scan NG
                ret
scan_pattern     ENDP

ifdef PCIROM
ifNdef  PCIBIOS_PAT_INLINE
location_msg    DB      0E1h,"EXIDE{[h̾ıڽ = ",0
endif
endif

;------ moved from xa7cwpat.inc
space_otesu     DB      "萔";"ł"
space_otesu_end label byte

;------ moved from xa13wpat.inc
space_nec       label   byte
                DB   "NEC Corp" ;"oration"
space_nec_end   label   byte

space_conner    label byte
                DB   "Conner Per" ;"pherals"
space_conner_end label byte

IF 0
;------------------------------------
;       ScanSpace48     output  ES:BX
;------------------------------------
ScanSpace48     PROC   near
                push    es
                mov     ax,MEMseg
                mov     es,ax
                mov     bx,1900h
                cld
ScanSpace48Ent:
                mov     cx,64
                mov     al,0
                mov     di,bx
        rep     scasb
                
                or      cx,cx
                jz      ScanSpace48Found
                inc     bx
                cmp     bx,1FF0h
                jb      ScanSpace48Ent
ScanSpace48Fail:
                pop     es
                stc
                ret
ScanSpace48Found:
                pop     es
                clc
                ret
ScanSpace48     ENDP
ENDIF

;---------------------------------------------------------
;       Beep Tone98Set
;---------------------------------------------------------
Tone98Set       PROC    near
                push    dx
                mov DX,03FDBh        ; 3FDB
                out DX,AL
                out     5Fh,al
               xchg AL,AH
                out DX,AL
                out     5Fh,al
                pop     dx
                ret
Tone98Set       ENDP
;--------------------------------------------------------
BeepSound       PROC   near
                call    Tone98Set
                mov     al,6            ; BEEP ON
                out 37h,al              
                mov     cx,bx
        @@:     out     5Fh,al  ; ҂
                out     5Fh,al
               loop     @b
                mov     al,7            ; BEEP OFF
                out 37h,al              
                mov     ax,04CDh        ; normal freq.
                call    Tone98Set
                ret
BeepSound       ENDP
;--------------------------------------------------------
;       Poop
;--------------------------------------------------------
Poop            PROC   near
                push    ax
                push    dx
                push    cx
                push    bx
                mov     ax,5000
                mov     bx,6543h 
                call    BeepSound
                pop     bx
                pop     cx
                pop     dx
                pop     ax
                ret
Poop            ENDP
;--------------------------------------------------------
;       Peee
;--------------------------------------------------------
Peee            PROC   near
                push    ax
                push    dx
                push    cx
                push    bx
                mov     ax,3750
                mov     bx,0FFF0h 
                call    BeepSound
                pop     bx
                pop     cx
                pop     dx
                pop     ax
                ret
Peee            ENDP
;-------------------------------------------------------------------
digit_1         PROC   near     ; input al
                push    si
                mov     si,offset num_space
                add     al,'0'  ; AL-->+30h  0-->"0"
                mov     cs:[si+1],al
                mov     dx,si
                call    _puts
                pop     si
                ret
num_space       DB      081h,20h,20h,0
digit_1         ENDP
;------------------------------------
;       Erase1Line
;------------------------------------
Erase1Line      PROC   near
                push    ROW
                mov     COLUMN,0
                mov     es,SegTVRAM ; ̕ϐ͊OIɊm肳Ă̂Ƃ
                mov     ax,80       ; Ps80
                mul     ROW         ; ̕ϐ͊OIɊm肵Ă̂Ƃ
                add     ax,COLUMN   ; ̕ϐ͊OIɊm肵Ă̂Ƃ
                shl     ax,1        ; VRAMAhXł2{
                mov     di,ax       ; DI=ɕ\JnʒuItZbgi[
                mov     ax,0020h    ; space code on VRAM
                mov     cx,80
        @@:     mov     byte ptr es:[di+2000h],0E1h
                stosw
               loop     @b
                pop     ROW
                ret
Erase1Line      ENDP
;===================================

