IDE_WINDOW_SEG      equ 09800h  ; IDE BIOSRAM WINDOW seg,EXIDEBX4ł͕ύX
;------------------------------------------------------------------------------
;Ql\[XvOî܂܃AZuROMł킯ł͂܂j
; PC-9801 BX4 IDE BIOS patch V5.20   Copyright(C) 2004-06,17-25 DOSsoft
;------------------------------------------------------------------------------
code            segment 
                assume cs:code,ds:code,es:code,ss:code
                org 100h  ; for MS-DOS .COM file
start:
                jmp     program_start
IDE_equip       equ     10h
SND_equip       equ     80h
include ..\pci\vars.h
MsgTitle  DB 0E1h,"IDE HDDeʏgCHSp[^ύXmANTI-CFؾān V5.20  Xe10/BX4",13,10,0
.386
program_start:  ; WX^͕ۑS ESDSCSŊJn
IF 0
                mov     dx,1E8Eh
                mov     al,81h
                out     dx,al
ENDIF
                enter   28,0            ; X^bNϐgp
                xor     ax,ax           ; ax=0
                mov     MachineType,al  ;=0
                mov     OldPCIPC,al     ;=0
                mov     Xe10BX4,al      ;=0
                mov     ax,offset ExtendedCode
                sub     ax,offset EndMain
                mov     LogicalSpace,ax

                cld                     ; ĂȂƈӊOƃgu
                mov     SegTVRAM,0A000h
                call    CheckModel9821  ; nC]^H98^9821̃`FbN
                jc      Invalid_PC9821  ; 9821 ID>21hłȂƂ
                call    GetDisplayLine  ; 98ITF̕\sǗɏ]
                mov     dx,offset MsgTitle 
                call    _puts   ; ^Cg\
                test    Xe10BX4,1
                jnz     @f
                mov     dx,offset wrong_msg
                call    _puts           ; uΉȂ@v̕\
                jmp     PatchCanceled   ; 
        @@:
                push    ROW
                call    Scan_GRPH_FK6   ; 2025-2-18 dlύX
                pop     ROW
                jc      PatchCanceled   ; 2024-9-15 ǉ

MachineOK_BX4: ;
                call    PeriEnvCheck    ; $$$

                call    GetMode       ; p[^[h̃`FbN
                jc      PatchCanceled

                call    IDEBIOS_Check   ; IDE BIOSǂy`FbN
                jc      PatchFinished
                mov     dx,offset IDE_msg
                call    _puts           ; u܂v̕\

                call    IDE_patch_BX4  ; $$$pb`Ămain
                jnc     PatchFinished   ; L[ȂΐI
                mov     dx,offset wrong_bios 
                call    _puts                   ; ̕\
PatchFinished:  
                call    ShiftKeyCheck   ; VtgL[pause
;               call    D800_WP         ; D800write protectԂɂ
PatchCanceled:
                call    SetDisplayLine
Invalid_PC9821:                         ; G[ÎƂɔł
                leave                   ; X^bNϐJ
                RET    ; C-bus boot ROM100h[_nearŖ߂

;=================================================================
;WarningOldPCIPC DB      0E1h," @ Xe10,BX4 ",0
;def_msg         DB      0E1h,"CHSp[^[h",0
type4GB_msg     DB      0E1h,"IDE 4351MBg",13,10,0
;type8GB_msg     DB      0E1h,"IDE 8063MB Ή@",13,10,0
wrong_bios      DB      0C1h,"ΉĂȂIDE BIOSł.",13,10,0 ; 
wrong_msg       DB      041h,"ΉĂȂ@ł.",13,10,0
IDE_msg         DB      0E1h,"IDE BIOS݂܂.  ",0
absent_msg      DB      041h,"IDE BIOSoĂ܂iڑj",13,10,0

;-------------------------------------------------------------------
;       MEMtoROM        MEMseg:0-->ES:0   ES=RAMwindow of IDE BIOS
;------------------------------------------------------------------
MEMtoROM        PROC    near
                cld
                mov     cx,2000h
                mov     si,0000h
                mov     di,0000h
                push    es      ; ES=D800h
                mov     ax,IDE_WINDOW_SEG
                mov     es,ax
                mov     ax,MEMseg
                push    ds      ; DS=MEMseg(5C00h)
                mov     ds,ax   ; DS=MEMseg, ES=RAMwindowIDE
           rep  movsb
                pop     ds
                pop     es
                ret
MEMtoROM        ENDP

;--------------------------------------------------------
;       IDEROMtoMEM        ds=D800:0-->MEMseg:0
;--------------------------------------------------------
IDEROMtoMEM     PROC    near
                cld
                mov     cx,2000h/2
                mov     si,0
                mov     di,0
                mov     dx,IDE_BIOS_SEG_D800
                mov     ax,MEMseg
                push    ds
                mov     ds,dx
                mov     es,ax
          rep   movsw
                pop     ds
                mov     al,ModeID
                mov     di,0007h
                stosb
                ret
IDEROMtoMEM     ENDP

;--------------------------------------------------------
;       BIOS_Bank_PCI   
;--------------------------------------------------------
BIOS_Bank_PCI   PROC    near
                mov     dx,063Ch
                in      al,dx
                mov     BIOS_BankStat,al    ; ݂̒lۊ
                and     al,0FCh
                or      al,01h          ; PCI BIOS
                out     dx,al
                ret
BIOS_Bank_PCI   ENDP

;--------------------------------------------------------
;       BIOS_Bank_IDE
;--------------------------------------------------------
BIOS_Bank_IDE   PROC    near
                mov     dx,063Ch
                in      al,dx
                mov     BIOS_BankStat,al    ; ݂̒lۊ
                and     al,0FCh         ; IDE BIOS
                out     dx,al
                ret
BIOS_Bank_IDE   ENDP

include legacy98.s

;--------------------------------------------------------
;       machines        ǉ
;--------------------------------------------------------
include bx4pat2.inc    ; pb`R[h  4351MB @p
include ..\pci\paramset.s      ; L[ɂ郂[hI[`

;--------------------------------------------------------
;       CheckModel9821  (excluding BX/BA)
;--------------------------------------------------------
CheckModel9821  PROC   near
                push    ds
                xor     ax,ax
                mov     ds,ax   ; ds=0
                mov     cl,ds:[0501h]   ; nC]tOق
                mov     ch,ds:[0458h]   ; gXWtOق
                mov     ax,0F8E8h
                mov     ds,ax
                mov     ax,ds:[0000h]   ; 9821CfBP[^
                mov     dl,ds:[003Fh]   ; @ID
                mov     dh,ds:[0005h]   ; PCItOق
                pop     ds
                test    cl,08h
                jnz     IsNot9821       ; hireso
                test    ch,80h
                jnz     IsNot9821       ; H98
                cmp     ax,2198h
                JE      Is9821series
IsNot9821:      stc     ; 9821łȂƂCY
                ret
Is9821series: ; 9821̉̋@ł
                cmp     dl,29h
                je      IsXe10BX4
                cmp     dl,22h
                je      IsXe10BX4
                jmp     Is9821
                cmp     dl,21h
                jae     Is9821
IsXe10BX4:      or      Xe10BX4,1
Is9821:         
                CLC     ; <---- EXIDEPCIłCY,EXIDEBX4ł NC $$$
                RET
                ret
CheckModel9821  ENDP
;-------------------------------------------------------------------------------

IFDEF MUTEING
_puts   PROC   near
        ret
_puts   ENDP
ELSE
include    e:\asmlib\putstrCS.inc   ; CS:DX\[`_puts͕t܂
ENDIF

;-------------------------------------------------------------------------------
include ..\pci\ideptcom.inc    ; PCI^PCI@routine,\[Ẍʒu͕ύX֎~
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
dmy             DD      0EEEEEEEEh      ; Ԃʂ邽߂̃_~[i폜֎~j
align 16
;   extdcode̐擪ł 2000hɓǂݑւ邽߃\[Ẍʒu̕ύX֎~
;-------------------------------------------------------------------------------
EndMain  label word  ; 
; oCił͏̋󔒂폜Ă悢
org     2000h   ; 5x00:2000Ɉʒu邱ƂɂȂ
include ..\pci\xcode4d.inc    ; Ă΂Ƃ2000hAf[^ANZX͂̑
;========================================================================
align 4
        DB      00h
DB      0,"̃vO̕ւ܂B",0,0,"(C)2025 ܂",0
        DB      150h dup(0) ; _~[̋
code    ends
        end     start
